# coffeelint: disable=max_line_length
_ = require 'lodash'
l2xconverter = require './l2xconverter'

debug = require("../../../shared_modules/logger").debug

module.exports = (message) ->
  outArray = []
  _.each message, (line) ->
    if line.match(/L2X/i)
      # extracting hex data
      splitLine = line.split ":"
      hexString = splitLine.pop()
      line = splitLine.join ":"

      #converting L2X to L3D
      l3dLines = l2xconverter(hexString)
      debug "l3dLines", l3dLines if l3dLines

      if l3dLines and l3dLines.length

        l3Line = l3dLines[0]
        newLine = "#{line}: #{l3Line}"
        newLine = newLine.split("L2X : ")[1] # /l2x/gi, "L3D"
        splitNewLine = newLine.split(" ")
        time = splitNewLine[1]
        time = time.replace /\.|\,/g, ":"
        splitNewLine[1] = "#{time} "
        newLine = splitNewLine.join(" ")

        #adding the line to output
        outArray.push newLine

        l3dLines.shift()

        # creating more lines without time
        _.each l3dLines, (l3Line) ->
          outArray.push "                            #{l3Line}"

  return outArray
