ko = require 'knockout'

Producer = require '../../ProducerClass'
parseLogLines = require './logLineParser'

debug = require("../../../shared_modules/logger").debug

testcallFolder = "/tmp/testcall"

class Gatelogs extends Producer
  constructor: ->
    super "testcalllogs"
    @running = ko.observable(false)

    onMessage = (err, status, message) =>
      @running((if status is "running" then true else false))
      # debug "received message from gatelogs, ", err, status, message
      if message
        #convert loglines to Layer 3 Messages L3D and send important lines
        outArray = parseLogLines message
        if outArray.length
          debug "parsed logs", outArray
          @emit "data", outArray

    debug "subscribing to gatelogs"
    @subscribeTo "gatelogs", onMessage

  start: =>
    debug "Testcall is requesting gatelogs to start"
    requestObject =
      producer: "gatelogs"
      action: "start"
      args: [2]
    @sendCommand requestObject

  stop: =>
    debug "Testcall is requesting gatelogs to stop"
    requestObject =
      producer: "gatelogs"
      action: "stop"
    @sendCommand requestObject

module.exports = new Gatelogs()
